> ## Documentation Index
> Fetch the complete documentation index at: https://docs.haiqu.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Backpropagate Observables

> Submit a job to backpropagate observables through the circuit.

Args:
    circuit_id (str): ID of the circuit.
    user (User): User authenticated with api key.
    data (SubmitObservableBackpropagationModel): Observables to backpropagate.

Returns:
    Response: 200 if OK, 404 if no such circuit exists.



## OpenAPI

````yaml https://api.haiqu.ai/openapi.json post /circuits/{circuit_id}/backpropagate_observables
openapi: 3.1.0
info:
  title: Haiqu API
  summary: Haiqu RESTful API service.
  description: Cloud service providing the access to Haiqu cloud runtime
  contact:
    name: Haiqu Inc.
    url: https://haiqu.ai/
    email: info@haiqu.ai
  version: 1.4.0
servers: []
security: []
paths:
  /circuits/{circuit_id}/backpropagate_observables:
    post:
      summary: Backpropagate Observables
      description: |-
        Submit a job to backpropagate observables through the circuit.

        Args:
            circuit_id (str): ID of the circuit.
            user (User): User authenticated with api key.
            data (SubmitObservableBackpropagationModel): Observables to backpropagate.

        Returns:
            Response: 200 if OK, 404 if no such circuit exists.
      operationId: >-
        backpropagate_observables_circuits__circuit_id__backpropagate_observables_post
      parameters:
        - name: circuit_id
          in: path
          required: true
          schema:
            type: string
            title: Circuit Id
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/SubmitObservableBackpropagationModel'
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema: {}
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyQuery: []
        - APIKeyHeader: []
components:
  schemas:
    SubmitObservableBackpropagationModel:
      properties:
        circuit_id:
          type: string
          title: Circuit Id
        observables:
          items:
            items:
              prefixItems:
                - type: string
                - type: number
                - type: number
              type: array
              maxItems: 3
              minItems: 3
            type: array
          type: array
          title: Observables
        max_qwc_groups:
          anyOf:
            - type: integer
            - type: 'null'
          title: Max Qwc Groups
        max_error_total:
          anyOf:
            - type: number
            - type: 'null'
          title: Max Error Total
        max_error_per_slice:
          anyOf:
            - type: number
            - type: 'null'
          title: Max Error Per Slice
      type: object
      required:
        - circuit_id
        - observables
      title: SubmitObservableBackpropagationModel
      description: Data model for observable backpropagation submit request
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
  securitySchemes:
    APIKeyQuery:
      type: apiKey
      in: query
      name: HAIQU_API_KEY
    APIKeyHeader:
      type: apiKey
      in: header
      name: authorization

````